  <div>
  <!--<div [formGroup]="form">-->
    <mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-3">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>{{lblHeaderLabel}}</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <dx-data-grid [dataSource]="addlCostsDataSource"
                      keyExpr="chargeTypeID"
                      [wordWrapEnabled]="true"
                      [rowAlternationEnabled]="true"
                      [showBorders]="true"
                      [columnAutoWidth]="true"
                      (onInitNewRow)="onInitNewRow($event)"
                      (onEditorPreparing)="onEditorPreparing($event)"
                      (onRowInserted)="onRowInserted($event)"
                      (onRowUpdated)="onRowUpdated($event)"
                      [disabled]="locked">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-editing mode="row"
                       [allowAdding]="isAddAllowed"
                       [allowUpdating]="true"
                       [allowDeleting]="true"
                       [useIcons]="true">
          </dxo-editing>
          <dxo-header-filter [visible]="true"></dxo-header-filter>
          <dxo-scrolling showScrollbar="always"></dxo-scrolling>

          <dxi-column type="buttons">
            <dxi-button name="history"
                        hint="History"
                        icon="clock"
                        [visible]="isHistoryAllowed"
                        [onClick]="onHistoryClicked"></dxi-button>
            <dxi-button name="edit"></dxi-button>
            <dxi-button name="delete"></dxi-button>
          </dxi-column>
          <dxi-column dataField="chargeTypeID"
                      caption="Type of Charge"
                      width="220">
            <dxi-validation-rule type="required"></dxi-validation-rule>
            <dxo-lookup [dataSource]="addlChargeTypeDataSource"
                        displayExpr="chargeTypeDesc"
                        valueExpr="chargeTypeID">
            </dxo-lookup>
          </dxi-column>
          <dxi-column dataField="chargeNRC"
                      caption="Addl Charge NRC"
                      alignment="left"
                      [visible]="isNCI">
            <dxi-validation-rule type="required"></dxi-validation-rule>
          </dxi-column>
          <dxi-column dataField="taxRate"
                      caption="Tax Rate (%)"
                      alignment="left"
                      [visible]="isNCI">
            <dxi-validation-rule type="required"></dxi-validation-rule>
          </dxi-column>
          <dxi-column dataField="currencyCd"
                      caption="Currency"
                      width="180"
                      [visible]="isNCI">
            <dxo-lookup [dataSource]="rtsCurrencyDataSource"
                        displayExpr="currencyDesc"
                        valueExpr="currencyCd">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxo-lookup>
          </dxi-column>
          <dxi-column type="buttons"
                      minWidth="45"
                      [visible]="isNCI">
            <dxi-button name="calculate"
                        hint="Calculate"
                        icon="money"
                        [visible]="isGridInEditMode"
                        [onClick]="onCalculateClicked">
            </dxi-button>
          </dxi-column>
          <dxi-column dataField="chargeNRCUSD"
                      caption="Total Cost (USD)"
                      alignment="left"
                      width="150"
                      [allowEditing]="false">
            <dxo-format type="currency" [precision]="2"></dxo-format>
          </dxi-column>
          <dxi-column dataField="note" minWidth="200"></dxi-column>
          <dxi-column dataField="statusID"
                      caption="Sales Status"
                      width="200">
            <dxo-lookup [dataSource]="rtsStatusDataSource"
                        displayExpr="statusDesc"
                        valueExpr="statusID">
            </dxo-lookup>
          </dxi-column>
          <dxi-column dataField="expirationTime"
                      caption="3 Day Timer Expiration"
                      [allowEditing]="false"
                      dataType="date"
                      width="120">
          </dxi-column>
          <dxi-column dataField="billOnly"
                      caption="BPA Required"
                      dataType="boolean"
                      [allowHeaderFiltering]="false"
                      [visible]="isNCI">
          </dxi-column>

          <dxo-summary [recalculateWhileEditing]="true">
            <dxi-total-item column="chargeNRCUSD"
                            summaryType="sum"
                            [valueFormat]="{ type: 'currency', precision: 2 }">
            </dxi-total-item>
          </dxo-summary>
        </dx-data-grid>


        <!-- Additional Costs -->
        <!--<dx-data-grid #gridCosts id="gridCosts"
                      [dataSource]="addlCostsDataSource"
                      [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                      [showBorders]="true" [columnAutoWidth]="true"
                      (onEditingStart)="editRecord($event)"
                      (onInitNewRow)="addNewRecord($event)"
                      (onContentReady)="contentReadyHandler($event)">

          <dxo-paging [enabled]="true" [pageSize]="15"></dxo-paging>
          <dxo-header-filter [visible]="true"></dxo-header-filter>
          <dxo-editing mode="row"
                       [allowUpdating]="true"
                       [allowAdding]="true">
          </dxo-editing>
          <dxi-column caption="View History" dataType="string" cellTemplate="hyperlink"></dxi-column>
          <div *dxTemplate="let cell of 'hyperlink'">
            <a class="text-secondary text-hover-primary" href="#" (click)="viewHistory(cell.data.chargeTypeID); false"><u>View History</u></a>
          </div>

          <dxi-column dataField="chargeTypeID"
                      caption="Type of Charge"
                      width="200">
            <dxo-lookup [dataSource]="addlChargeTypeDataSource"
                        displayExpr="chargeTypeDesc"
                        valueExpr="chargeTypeID">
            </dxo-lookup>
          </dxi-column>
          <div *dxTemplate="let cellInfo of 'chargeTypeDropDownBoxEditor'">
            <dx-drop-down-box [dataSource]="addlChargeTypeDataSource"
                              displayExpr="chargeTypeDesc"
                              valueExpr="chargeTypeID">
            </dx-drop-down-box>
          </div>
          <dxi-column dataField="chargeNRC" caption="Addl Charge NRC">
          </dxi-column>
          <dxi-column dataField="taxRate" caption="Tax Rate (%)">
          </dxi-column>
          <dxi-column dataField="currencyCd"
                      caption="Currency"
                      width="200">
            <dxo-lookup [dataSource]="rtsCurrencyDataSource"
                        displayExpr="currencyDesc"
                        valueExpr="currencyCd">
            </dxo-lookup>
          </dxi-column>
          <dxi-column caption="Calculate" dataType="string" cellTemplate="calculate"></dxi-column>
          <div *dxTemplate="let cell of 'calculate'">
            <a class="text-secondary text-hover-primary" href="#" (click)="false"><u>Calculate</u></a>
          </div>
          <dxi-column caption="Re-Open Charge" dataType="string" cellTemplate="reOpenCharge"></dxi-column>
          <div *dxTemplate="let cell of 'reOpenCharge'">
            <a class="text-secondary text-hover-primary" href="#" (click)="viewHistory(cell.data.chargeTypeID); false"><u>View History</u></a>
          </div>
          <dxi-column dataField="chargeNRCUSD" caption="Total Cost (USD)" alignment="left" format="currency" [editorOptions]="editorOptions" [calculateCellValue]="calculateToTalCost"></dxi-column>
          <dxo-summary [recalculateWhileEditing]="true">
            <dxi-total-item column="chargeNRCUSD"
                            summaryType="sum"
                            valueFormat="currency">
            </dxi-total-item>
          </dxo-summary>

          <dxi-column dataField="note">
          </dxi-column>
          <dxi-column dataField="statusID"
                      caption="Sales Status"
                      width="200">
            <dxo-lookup [dataSource]="rtsStatusDataSource"
                        displayExpr="statusDesc"
                        valueExpr="statusID">
            </dxo-lookup>
          </dxi-column>
          <div *dxTemplate="let cellInfo of 'statusDropDownBoxEditor'">
            <dx-drop-down-box [dataSource]="rtsStatusDataSource"
                              [(value)]="cellInfo.value"
                              displayExpr="statusDesc"
                              valueExpr="statusID">
            </dx-drop-down-box>
          </div>
          <dxi-column dataField="expirationTime" caption="3 Day Timer Expiration" dataType="date"></dxi-column>
          <dxi-column dataField="billOnly" caption="BPA Required" dataType="boolean"
                      [allowHeaderFiltering]="false"></dxi-column>
        </dx-data-grid>-->
        <div class="form-row text mt-2">
          <div class="form-group form-group-sm col-12 col-md-4 col-lg-4">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="onSaveClicked($event)" [disabled]="locked">
              Save Additional Costs
            </button>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!--Additional Cost History-->
    <mat-accordion>
      <mat-expansion-panel [expanded]="true" class="mb-3">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Additional Cost History</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div *ngIf="displayGrid">
          <dx-data-grid #gridHistory id="gridHistory" class="mb-3" [dataSource]="addlCostHistoryDataSource"
                        [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                        [showBorders]="true" [columnAutoWidth]="true" [disabled]="locked">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
            <dxo-scrolling mode="standard" useNative="false"></dxo-scrolling>

            <dxi-column dataField="version" caption="Version" dataType="string"></dxi-column>
            <dxi-column dataField="chargeTypeDesc" caption="Charge Type" dataType="string"></dxi-column>
            <dxi-column dataField="currencyCd" caption="Currency" dataType="string"></dxi-column>
            <dxi-column dataField="chargeNRC" caption="NRC Charge" dataType="number" format="currency"></dxi-column>
            <dxi-column dataField="chargeNRCUSD" caption="NRC Charge USD" dataType="number" format="currency"></dxi-column>
            <dxi-column dataField="taxRate" caption="Tax Rate" dataType="string"></dxi-column>
            <dxi-column dataField="note" caption="Note" dataType="string"></dxi-column>
            <dxi-column dataField="salesSupportStatusDes" caption="Sales Status" dataType="string"></dxi-column>
            <dxi-column dataField="expirationTime" caption="72 Hour Timer" dataType="date"></dxi-column>
            <dxi-column dataField="billOnly" caption="BPA Required" dataType="string"></dxi-column>
            <dxi-column dataField="createdByDspNme" caption="Created By" dataType="string"></dxi-column>
            <dxi-column dataField="createdDateTime" caption="Create Date" dataType="date"></dxi-column>
          </dx-data-grid>
        </div>
      </mat-expansion-panel>
    </mat-accordion>
  </div>
